



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>BeanPostProcessor —— 连接Spring IOC和AOP的桥梁</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">BeanPostProcessor —— 连接Spring IOC和AOP的桥梁</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 02:18:41 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>之前都是从大Boss的视角，来介绍Spring，比如IOC、AOP。</p>
<p>今天换个视角，从一个小喽啰出发，来加深对Spring的理解。</p>
<p>这个小喽啰就是，&nbsp;BeanPostProcessor&nbsp;（下面简称&nbsp;BBP&nbsp;）。</p>
<p>讲解思路：</p>
<ul><li>BBP怎么用 &mdash;&mdash; 先学会怎么用，再去看原理</li>
<li>BBP的触发时机 &mdash;&mdash; 在整个Spring Bean初始化流程中的位置</li>
<li>BBP自己又是什么时候被创建的？</li>
<li>BBP是如何连接IOC和AOP的？</li></ul>
<h2>怎么用</h2>
<p>BeanPostProcessor，直译过来，就是&ldquo;对象后处理器&rdquo;，&nbsp;那么这个&ldquo;后&rdquo;，是指什么之后呢？</p>
<p>试试便知。</p>
<p>我们先写一个对象，Bean4BBP（&nbsp;本文的所有代码，可到&nbsp;<a href="https://github.com/hzy38324/Spring-Boot-Practice" rel="external nofollow noreferrer">Github</a>&nbsp;上下载&nbsp;）：</p>
<div>
<pre class="prettyprint linenums">@Component<br />
public class Bean4BBP {

    private static final Logger log = LoggerFactory.getLogger(Bean4BBP.class);

    public Bean4BBP(){<br />
        log.info("construct Bean4BBP");<br />
    }<br />
}</pre>
</div>
<p>然后再写一个BeanPostProcessor，这时发现它是一个接口，没关系，那就写一个类实现它，CustomBeanPostProcessor：</p>
<div>
<pre class="prettyprint linenums">@Component<br />
public class CustomBeanPostProcessor implements BeanPostProcessor {

    private static final Logger log = LoggerFactory.getLogger(CustomBeanPostProcessor.class);

    public CustomBeanPostProcessor() {<br />
        log.info("construct CustomBeanPostProcessor");<br />
    }

    @Override<br />
    public Object postProcessBeforeInitialization(Object bean, String beanName) throws BeansException {<br />
        if (bean instanceof Bean4BBP) {<br />
            log.info("process bean before initialization");<br />
        }<br />
        return bean;<br />
    }

    @Override<br />
    public Object postProcessAfterInitialization(Object bean, String beanName) throws BeansException {<br />
        if (bean instanceof Bean4BBP) {<br />
            log.info("process bean after initialization");<br />
        }<br />
        return bean;<br />
    }<br />
}</pre>
</div>
<p>然后启动我们的Spring Boot项目（直接运行Application类），看这几条日志打印的顺序：</p>
<div>
<pre class="prettyprint linenums">construct CustomBeanPostProcessor<br />
construct Bean4BBP<br />
process bean before initialization<br />
process bean after initialization</pre>
</div>
<p>BBP对象首先被创建，然后创建Bean4BBP对象，接着再先后执行BBP对象的postProcessBeforeInitialization和postProcessAfterInitialization方法。</p>
<p>结论：&ldquo;对象后处理器&rdquo;，指的是&ldquo;&nbsp;对象创建后处理器&nbsp;&rdquo;。</p>
<p>我们可以利用它，在对象创建之后，对对象进行修改（有什么场合需要用到？思考题，文末回答。）</p>
<p>那么，为什么要分postProcessBeforeInitialization和postProcessAfterInitialization呢？这里的Initialization是什么意思？</p>
<h2>触发时机</h2>
<p>我们只需要在CustomBeanPostProcessor的postProcessBeforeInitialization和postProcessAfterInitialization方法里，打上两个断点，一切自然明了。</p>
<p>断点进来，跟着调用栈这点蛛丝马迹往回走，真相大白：&nbsp;<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1420036/201806/1420036-20180619174318535-1701702219.png" /></p>
<div>
<p>在initializeBean方法里面，先后调用了applyBeanPostProcessorsBeforeInitialization和applyBeanPostProcessorsAfterInitialization方法，这两个方法内部，则分别去遍历系统里所有的BBP，然后逐个执行这些BBP对象的postProcessBeforeInitialization和postProcessAfterInitialization方法，去处理对象，以applyBeanPostProcessorsBeforeInitialization为例：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1420036/201806/1420036-20180619174328528-791193558.png" /></div>
<p>那么夹在applyBeanPostProcessorsBeforeInitialization和applyBeanPostProcessorsAfterInitialization方法中间的invokeInitMethods方法是做什么的呢？</p>
<p>其实这个方法就是Spring提供的，用于对象创建完之后，针对对象的一些初始化操作。这就好比你创建了一个英雄之后，你需要给他进行一些能力属性的初始化、服装初始化一样。</p>
<p>要验证这一点，很简单，只需让Bean4BBP实现InitializingBean接口：</p>
<div>
<pre class="prettyprint linenums">@Component<br />
public class Bean4BBP implements InitializingBean {

    private static final Logger log = LoggerFactory.getLogger(Bean4BBP.class);

    public Bean4BBP(){<br />
        log.info("construct Bean4BBP");<br />
    }

    @Override<br />
    public void afterPropertiesSet() throws Exception {<br />
        log.info("init Bean4BBP");<br />
    }<br />
}</pre>
</div>
<p>然后重新启动工程，打印顺序如下：</p>
<div>
<pre class="prettyprint linenums">construct CustomBeanPostProcessor<br />
construct Bean4BBP<br />
process bean before initialization<br />
init Bean4BBP<br />
process bean after initialization</pre>
</div>
<h2>BBP是什么时候被初始化的</h2>
<p>从上面的代码片段，我们已经知道，在对象创建之后，需要遍历BBP列表，对对象进行处理。</p>
<p>这也就意味着，&nbsp;BBP对象，必须在普通对象创建之前被创建&nbsp;。</p>
<p>那么BBP都是在什么时候被创建的呢？</p>
<p>要回答这个问题，非常简单，&nbsp;我们只需要在CustomBeanPostProcessor的构造函数里打个断点&nbsp;（这下看到先学会用，再了解原理的好处了吧）</p>
<div>
<p>断点进来，继续利用调用栈，我们找寻到了AbstractApplicationContext的refresh()方法，这个方法里面调用了registerBeanPostProcessors方法，里头就已经把BBP列表创建好了，而普通对象的创建，是在之后的finishBeanFactoryInitialization方法里执行的：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1420036/201806/1420036-20180619174400107-1555694182.png" /></div>
<div>
<p>网上有个图画的特别好，很好的展示了BBP在Spring对象初始化流程的位置：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1420036/201806/1420036-20180619174407090-1216685744.jpg" /></p>
<p>（看到BBP在哪了吗？）</p>
</div>
<h2>BBP的典型使用 - AOP</h2>
<div>
<p>不知道大家在使用Spring AOP时，有没有发现，带有切面逻辑的对象，注入进来之后，都不是原来的对象了，比如下图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1420036/201806/1420036-20180619174428780-414992113.png" /></div>
<p>调试信息显示，aspectService是一个&hellip;$$EnhanceBySpringCGlib的对象，这其实和Spring AOP用到的动态代理有关。</p>
<p>关于Spring AOP的原理，可以参考我之前的回答：&nbsp;<a href="https://www.zhihu.com/question/24863332/answer/350410712" rel="external nofollow noreferrer">什么是面向切面编程AOP？ - Javdroider Hong的回答 - 知乎</a></p>
<p>这也就意味着，&nbsp;最终放进Spring容器的，必须是代理对象，而不是原先的对象&nbsp;，这样别的对象在注入时，才能获得带有切面逻辑的代理对象。</p>
<p>那么Spring是怎么做到这一点的呢？正是利用了这篇文章讲到的BBP。</p>
<p>显然，我只需要写一个BBP，在postProcessBeforeInitialization或者postProcessAfterInitialization方法中，对对象进行判断，看他需不需要织入切面逻辑，如果需要，那我就根据这个对象，生成一个代理对象，然后返回这个代理对象，那么最终注入容器的，自然就是代理对象了。</p>
<p>这个服务于Spring AOP的BBP，叫做&nbsp;AnnotationAwareAspectJAutoProxyCreator&nbsp;.</p>
<div>
<p>利用idea的diagram功能，可以看出它和BBP的关系：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1420036/201806/1420036-20180619174438293-1334944620.png" /></div>
<p>具体的创建代理对象并返回的逻辑，在postProcessAfterInitialization方法中，大家自行欣赏。</p>
<h4>可以说，如果没有BBP，那么Spring AOP就只能叫AOP。</h4>
<h4>BBP是连接IOC和AOP的桥梁。</h4>
<h2>总结</h2>
<p>这篇文章，主要通过对BBP的讲解，串联起之前讲到的关于Spring的知识，希望能够加深大家对Spring的理解。</p>
<p>最后，回到开头提出的四个问题：</p>
<ul><li>BBP怎么用 &mdash;&mdash; 先学会怎么用，再去看原理</li>
<li>BBP的触发时机 &mdash;&mdash; 在整个Spring Bean初始化流程中的位置</li>
<li>BBP自己又是什么时候被创建的？</li>
<li>BBP是如何连接IOC和AOP的？</li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495ppv0q.html">cf723a The New Year&colon; Meeting Friends</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn4op28.html">【Spring】Spring框架之Struts2和Spring的优点</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqld3ne9.html">Repeater 双向排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m5nzoq.html">day8-多进程和多线程</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k34n7q.html">IOS应用程序生命周期的AppDelegate详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mmpkeq.html">wechat</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydv4oxq.html">【风马一族&lowbar;Android】通过菜单的点击，跳转到不同界面</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd4mgmq.html">从Windows 服务器通过sync向Linux服务器定时同步文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv0nmjq.html">Part 15 Scalar user defined functions in sql server</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnxro6q.html">TCP&sol;IP三次握手</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zole69.html">android 5&period;0 创建多用户 双开多开应用（2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y0menq.html">iOS- UITableView could not hold the selected row after reload</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yopez8.html">BZOJ 2882&colon; 工艺&lpar; 后缀自动机 &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkegjv8.html">web与request</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdxlmk9.html">windows环境搭建jira 详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rnj248.html">流媒体技术学习笔记之（一）nginx&plus;nginx-rtmp-module&plus;ffmpeg搭建流媒体服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/96306on9.html">微信公众号抢现金红包活动的核心代码分析&lpar;asp&period;net C&num;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjjd3p8.html">python 入门练习</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2l3gz8.html">TACOTRON&colon;端到端的语音合成</a>
		</li>
						<li><a href="https://www.batexi.com/a/8od4x75q.html">numpy切片和布尔型索引</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qyy13dxq.html">记录一次网站邮箱（STMP）被恶意伪造事件</a>
			</li>
						<li><a href="https://www.batexi.com/a/960pw539.html">Vue  element  分页</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllj3x0q.html">iserver频繁崩溃、内存溢出事故解决小记</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2e522q.html">windows service 2008 R2 升级 sp1遇到的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvjxkk8.html">UVa540</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdk3gz9.html">hive资料</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy1k1gq.html">设计模式学习心得&amp;lt&semi;组合模式 Composite&amp;gt&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyod719.html">MongoDB学习记录&lpar;四&rpar; - MongoDB的&amp;quot&semi;增查改删&amp;quot&semi;操作之&amp;quot&semi;改&amp;quot&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwp6rj9.html">MUI中超链接失效解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ozp3k8.html">SAS 函数</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
